
;===========
;	Includes
;===========



;===========
;	Globals
;===========


Global Quit=False
Global Camera
Global Player
Global PX#,PY#,PZ#
Global plane 
Global PPick
Global CPiv ;  
Global CPivSp# ;     


;	Settings

Global wh%=1024,ww%=768,bit%=32,sm%=2
;==============================
Const TypePlayer=1,TypeWalls=2,TypePlane=3


;	Initialization

Window()
Player() 
World()
Camera()



Repeat

CamControl()
PlayerMove()

MoveEntity player,0,-.1,0


Collisions TypePlayer, TypeWalls, 2, 3
Collisions TypePlayer, TypePlane, 2, 3

If KeyHit(1) Then Quit=True

UpdateWorld
RenderWorld



Flip

Until Quit

End

Function Window()
Graphics3D wh%,ww%,bit%,sm%
SetBuffer BackBuffer()
SeedRnd MilliSecs()
AppTitle "Movement"
End Function 

Function Player()

player=LoadAnimMesh("data\models\robot\standing.3DS")
LoadAnimSeq Player,"data\models\Robot\running.3ds" 
ScaleEntity Player,0.08,0.08,0.08 
EntityRadius Player, 1.5
EntityType Player,TypePlayer
PositionEntity player,0,5,0
Animate Player,2,1,0,10

End Function  

Function World()

AmbientLight 220,220,220
plane=CreatePlane()
EntityType plane,TypePlane
textplane=LoadTexture("1.jpg") 
ScaleTexture textplane,20,20 
EntityTexture plane,textplane 
EntityPickMode plane,2
tex=LoadTexture("2.jpg")
ScaleTexture tex,1,1



cube=CreateCube()
PositionEntity Cube,6,0.5,0
EntityColor cube,255,205,155
ScaleEntity cube,0.5,2,8

cube2=CreateCube()
PositionEntity Cube2,-6,0.5,0
EntityColor cube2,255,205,155
ScaleEntity cube2,0.5,2,8

cube3=CreateCube()
PositionEntity Cube3,0,0.5,-7
EntityColor cube3,255,205,155
ScaleEntity cube3,5.5,2,1

EntityTexture cube,tex
EntityTexture cube2,tex
EntityTexture cube3,tex

EntityType cube,TypeWalls
EntityType cube2,TypeWalls
EntityType cube3,TypeWalls

EntityPickMode cube,2
EntityPickMode cube2,2
EntityPickMode cube3,2


End Function

Function Camera()

CPiv=CreatePivot();      
PPick=CreatePivot();   


Camera=CreateCamera(CPiv)
CameraZoom camera,1.5
CameraRange camera,1,700
CameraClsColor camera,0, 70, 150
CameraFogMode camera,1
CameraFogRange camera,10,300
CameraFogColor camera,150,150,150
PositionEntity camera,0,25,25
PointEntity camera, player;    

End Function

Function CamControl()
CPivSp#=1

dx#=(EntityX(player) - EntityX(CPiv)  )*CPivSp#
dy#=(EntityY(player) - EntityY(CPiv)  )*CPivSp#
dz#=(EntityZ(player) - EntityZ(CPiv)  )*CPivSp#
TranslateEntity CPiv,dx,dy,dz  ;     

End Function

Function PlayerMove()
MH1=MouseHit(1)
MH2=MouseHit(2)
MH3=MouseHit(3)
If MH1 
		CameraPick (Camera, MouseX(),MouseY()) 
		If PickedEntity()=plane
			
			PX#=PickedX ()
			PY#=PickedY ()
			PZ#=PickedZ () 
			
			PositionEntity PPick,PX,PY,PZ
			PointEntity(Player,PPick)
			RotateEntity Player,0,EntityYaw(Player)+180,0
			
		EndIf
EndIf


If EntityDistance(Player,PPick)>.1 
		
	If AnimSeq(Player)=0
		Animate Player,1,.5,1,10
   EndIf 
		MoveEntity Player,0,0,-0.16
   Else
	If AnimSeq(Player)=1
		Animate Player,2,1,0,10
   EndIf
EndIf 


End Function

